package main

const goModelFile = `
// This code was autogenerated from {{.GetName}}, do not edit.
{{- $pkgName := GoPackageName .}}
{{- $imports := GetImports .}}
{{- $isPointerStrictMode :=  IsPointerStrictMode . }}

{{- $goModelMessage := GetGoModelMessage .}}
{{- $goModelName := UppercaseFirst $goModelMessage.Name }}
{{- $goRepoName := printf "%s%s" $goModelName "DefaultRepository" }}
{{- $modelDbName := GetModelDbName . }}

package {{$pkgName}}

import (
	"errors"
	mongodb "git.tutum.dev/medi/tutum/ares/pkg/repo"
	"git.tutum.dev/medi/tutum/ares/pkg/repo/mongodb_repo"
	"github.com/google/uuid"
	"gitlab.com/silenteer-oss/titan"
	"strings"
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo/options"
	{{ range $importPath, $packageName := $imports }}
		{{ $packageName }} "{{ $importPath }}"
	{{ end }}
)

var _ goff.UUID

// Model definitions
{{- range $index, $type := .MessageType }}
	{{- $extendFromType := GetGoMessageExtendFromType $type}}
	{{- if ne $extendFromType "" }}
		type {{ $type.Name }} = {{ $extendFromType }} 
	{{ else }}
		type {{ $type.Name }} struct {
		{{- range $fieldIndex, $field := $type.Field }}
		{{- $customOption := GetGoModelFieldCustomOption $field $type.Name $goModelName }}
			{{ UppercaseFirst $field.Name}}	{{ GoType $field $isPointerStrictMode }} {{ BackTick }}{{ $customOption }}{{ BackTick }}
		{{- end}}
		}
	{{end}}
{{- end }}

// Enum definitions
{{- $enums := .EnumType }}
{{- range $index, $type := $enums }}
    {{- $ofType := GetGoEnumFromType $type}}
	{{- if ne $ofType "" }}
		 type {{ $type.Name }} {{$ofType}}
	{{ else }}
		type {{ $type.Name }} string
	{{end}}
    const(
    {{- range $fieldIndex, $field := $type.Value }}
        {{$field.Name}} {{ $type.Name }} = "{{GetEnumValue $field}}"
    {{- end}}
    )
{{- end }}

// Model fields definitions
{{- range $index, $type := .MessageType }}
	const (
	{{- range $index, $field := $type.Field }}
		{{ GetGoModelFieldName $field $type.Name $goModelName }} = "{{ GetBsonName $field $type.Name $goModelName }}"
	{{- end }}
	)
{{- end }}

// Repo definitions
type {{$goRepoName}} struct {
	Db mongodb.IDBClient
}

{{if ne $modelDbName ""}}
func New{{$goRepoName}}()  {{$goRepoName}} {
	return {{$goRepoName}}{
		Db: mongodb_repo.NewMongoDbIDBClient("{{ $modelDbName }}", "{{ GetModelCollectionName $goModelMessage}}", {{GetModelIsTenant $goModelMessage}}),
	}
}
{{ end }}


func (r *{{$goRepoName}}) Find(ctx *titan.Context, filter interface{}, opts ...*options.FindOptions) ([]{{$goModelName}}, error) {
	var data []{{$goModelName}}
	err := r.Db.Find(ctx, filter, &data, opts...)
	if err != nil {
		return []{{$goModelName}}{}, err
	}
	return data, nil
}

func (r *{{$goRepoName}}) FindOne(ctx *titan.Context, filter interface{}, opts ...*options.FindOneOptions) (*{{$goModelName}}, error) {
	var data {{$goModelName}}
	err := r.Db.FindOne(ctx, filter, &data, opts...)
	if err != nil {
		return nil, err
	}
	if data.Id != nil {
	    return &data, nil
	}
	return nil, nil
}

func (r *{{$goRepoName}}) Aggregate(
	ctx *titan.Context,
	filter interface{},
	opts ...*options.AggregateOptions) ([]{{$goModelName}}, error) {

	var entities []{{$goModelName}}
	err := r.Db.Aggregate(ctx, filter, &entities)

	if err != nil {
		return []{{$goModelName}}{}, err
	}

	return entities, nil
}

func (r *{{$goRepoName}}) FindById(ctx *titan.Context, uuid uuid.UUID) (*{{$goModelName}}, error) {
	filter := bson.D{{DoubleOpenBracket}}
		Key:   Field_Id,
		Value: uuid,
	{{DoubleCloseBracket}}

	data, err := r.Find(ctx, filter)
	if err != nil {
		return nil, err
	}

	if len(data) == 0 {
		return nil, nil
	}

	return &data[0], nil
}

func (r *{{$goRepoName}}) GetById(ctx *titan.Context, uuid uuid.UUID) (*{{$goModelName}}, error) {
	data, err := r.FindById(ctx, uuid)
	if err != nil {
		return nil, err
	}

	if data == nil {
		return nil, titan.NewRecordNotFoundException("{{$goModelName}}", uuid.String(), "NOT_FOUND_RECORD")
	}
	return data, nil
}

func (r *{{$goRepoName}}) GetByIds(ctx *titan.Context, uuids []uuid.UUID) (data []{{$goModelName}}, err error) {
	filter := bson.D{
		{
			Key: Field_Id,
			Value: bson.D{
				{
					Key:   "$in",
					Value: uuids,
				},
			},
		},
	}
	err = r.Db.Find(ctx, filter, &data)
	return data, err
}

func (r *{{$goRepoName}}) Create(ctx *titan.Context, request {{$goModelName}}) (*{{$goModelName}}, error) {
	var data {{$goModelName}}
	err := r.Db.Create(ctx, request, &data)
	if err != nil {
		return nil, err
	}
	return &data, nil
}

func (r *{{$goRepoName}}) CreateMany(ctx *titan.Context, requests []{{$goModelName}}) ([]{{$goModelName}}, error) {
	var data []{{$goModelName}}
	err := r.Db.Create(ctx, requests, &data)
	if err != nil {
		return make([]{{$goModelName}}, 0), err
	}
	return data, nil
}

func (r *{{$goRepoName}}) Delete(ctx *titan.Context, filter interface{}) (int64, error) {
	res, err := r.Db.Delete(ctx, filter)

	if err != nil {
		return 0, err
	}

	return res.DeletedCount, nil
}

func (r *{{$goRepoName}}) DeleteById(ctx *titan.Context, id uuid.UUID) (bool, error) {
	filter := bson.D{{DoubleOpenBracket}}Key: Field_Id, Value: id{{DoubleCloseBracket}}
	res, err := r.Delete(ctx, filter)
	if err != nil {
		return false, err
	}
	if res != 1 {
		return false, errors.New("delete_failed")
	}

	return true, nil
}

func (r *{{$goRepoName}}) FindOneAndUpdate(ctx *titan.Context, filter interface{}, update interface{}, opts ...*options.FindOneAndUpdateOptions) (*{{$goModelName}}, error) {
	var entity {{$goModelName}}
	err := r.Db.FindOneAndUpdate(ctx, filter, update, &entity, opts...)
	if err != nil {
		return nil, err
	}
	return &entity, nil
}

func (r *{{$goRepoName}}) FindOneAndReplace(ctx *titan.Context, filter interface{}, replacement {{$goModelName}}, opts ...*options.FindOneAndReplaceOptions) (*{{$goModelName}}, error) {
	var entity {{$goModelName}}
	err := r.Db.FindOneAndReplace(ctx, filter, replacement, &entity, opts...)
	if err != nil {
		return nil, err
	}
	return &entity, nil
}

func (r *{{$goRepoName}}) Update(ctx *titan.Context, update {{$goModelName}}) (*{{$goModelName}}, error) {
	var entity {{$goModelName}}
	err := r.Db.Update(ctx, update, &entity)
	if err != nil {
		return nil, err
	}
	return &entity, nil
}

func (r *{{$goRepoName}}) UpdateMany(ctx *titan.Context, update []{{$goModelName}}) ([]{{$goModelName}}, error) {
	var entities []{{$goModelName}}
	err := r.Db.Update(ctx, update, &entities)
	if err != nil {
		return nil, err
	}
	return entities, nil
}

func (r *{{$goRepoName}}) Upsert(ctx *titan.Context, request {{$goModelName}}) (*{{$goModelName}}, error) {
	filter := bson.D{{DoubleOpenBracket}}Key: Field_Id, Value: request.Id{{DoubleCloseBracket}}
	opts := options.FindOneAndReplace().SetReturnDocument(options.After).SetUpsert(true)

	entity, err := r.FindOneAndReplace(ctx, filter, request, opts)

	if err != nil {
		if isDupkeyErr(err) {
			return r.FindById(ctx, *request.Id)
		}
		return nil, err
	}

	if entity.Id == nil {
		return nil, errors.New("no_response_data")
	}

	return entity, nil
}

func (r *{{$goRepoName}}) Count(
	ctx *titan.Context,
	filter interface{}) (int64, error) {

	response, err := r.Db.Count(ctx, filter)

	if err != nil {
		return 0, err
	}

	return response.Count, nil
}

func (r *{{$goRepoName}}) GetCollectionName(ctx *titan.Context) (string, error) {
	response, err := r.Db.GetCollectionName(ctx)

	if err != nil {
		return "", err
	}

	return response, nil
}

func isDupkeyErr(err error) bool {
	err = errors.Unwrap(err)
	_err, ok := err.(*titan.ClientResponseError)
	if !ok {
		return false
	}
	if !strings.Contains(string(_err.Response.Body), "index: _id_ dup key:") {
		return false
	}

	return true
}

`
